diff --git a/src/ewmh.c b/src/ewmh.c
index c4ae844ea..0e152418f 100644
--- a/src/ewmh.c
+++ b/src/ewmh.c
@@ -123,16 +123,17 @@ void ewmh_update_desktop_viewport(void) {
                         A__NET_DESKTOP_VIEWPORT, XCB_ATOM_CARDINAL, 32, current_position, &viewports);
 }
 
-static void ewmh_update_wm_desktop_recursively(Con *con, const uint32_t desktop) {
+static void ewmh_update_wm_desktop_recursively(Con *ws, Con *con, const uint32_t desktop) {
     /* Recursively call this to descend through the entire subtree. */
     Con *child;
     TAILQ_FOREACH(child, &(con->nodes_head), nodes) {
-        ewmh_update_wm_desktop_recursively(child, desktop);
+        ewmh_update_wm_desktop_recursively(ws, child, desktop);
     }
+
     /* If con is a workspace, we also need to go through the floating windows on it. */
     if (con->type == CT_WORKSPACE) {
         TAILQ_FOREACH(child, &(con->floating_head), floating_windows) {
-            ewmh_update_wm_desktop_recursively(child, desktop);
+            ewmh_update_wm_desktop_recursively(ws, child, desktop);
         }
     }
 
@@ -151,6 +152,13 @@ static void ewmh_update_wm_desktop_recursively(Con *con, const uint32_t desktop)
         wm_desktop = NET_WM_DESKTOP_ALL;
     }
 
+    /* If the window is on the scratchpad we assign the sticky value to it
+     * since showing it works on any workspace. We cannot remove the property
+     * as per specification. */
+    if (con_is_internal(ws)) {
+        wm_desktop = NET_WM_DESKTOP_ALL;
+    }
+
     /* If this is the cached value, we don't need to do anything. */
     if (con->window->wm_desktop == wm_desktop)
         return;
@@ -179,11 +187,11 @@ void ewmh_update_wm_desktop(void) {
     TAILQ_FOREACH(output, &(croot->nodes_head), nodes) {
         Con *workspace;
         TAILQ_FOREACH(workspace, &(output_get_content(output)->nodes_head), nodes) {
-            if (con_is_internal(workspace))
-                continue;
+            ewmh_update_wm_desktop_recursively(workspace, workspace, desktop);
 
-            ewmh_update_wm_desktop_recursively(workspace, desktop);
-            ++desktop;
+            if (!con_is_internal(workspace)) {
+                ++desktop;
+            }
         }
     }
 }
diff --git a/testcases/t/529-net-wm-desktop.t b/testcases/t/529-net-wm-desktop.t
index f6a3b2184..8f2df735a 100644
--- a/testcases/t/529-net-wm-desktop.t
+++ b/testcases/t/529-net-wm-desktop.t
@@ -345,6 +345,26 @@ is(get_net_wm_desktop($con), 0xFFFFFFFF, '_NET_WM_DESKTOP is updated');
 kill_windows;
 exit_gracefully($pid);
 
+###############################################################################
+# _NET_WM_DESKTOP is updated when a window is moved to the scratchpad.
+###############################################################################
+
+$pid = launch_with_config($config);
+
+cmd 'workspace 0';
+$con = open_window;
+cmd 'floating enable';
+is(get_net_wm_desktop($con), 0, '_NET_WM_DESKTOP is set sanity check)');
+
+cmd 'move scratchpad';
+is(get_net_wm_desktop($con), 0xFFFFFFFF, '_NET_WM_DESKTOP is updated');
+
+cmd 'scratchpad show';
+is(get_net_wm_desktop($con), 0, '_NET_WM_DESKTOP is set sanity check)');
+
+kill_windows;
+exit_gracefully($pid);
+
 ###############################################################################
 
 done_testing;
